<template>
  <cabinet-layout nav-active="profile">
    <div
      slot="block-content"
      class="wrench">
      <submenu item-active="organization-sto"/>
      <div class="container">
        <div class="kit breadcrumb">
          <div class="section">
            <flink href="/cabinet/wrench/organization-sto">Магазины запчастей и автотехцентры</flink>
          </div>
          <div class="section active">
            <flink>Добавление нового автотехцентра</flink>
          </div>
        </div>
        <div class="title">
          Добавление нового автотехцентра
        </div>
        <form-new-sto
          :information="information"
          :shop-attributes-options="shopAttributes"
          :payment-methods-options="paymentMethods"
          :additional-contact-methods-options="additionalContactMethods"
          :car-manufacturers-list="carManufacturerWithRegionList"
          :list-service="listService"
          :location="location"
          :auth="auth"
          display-type="sto"
          action-type="new"/>

      </div>
    </div>
    <div slot="line-modal">
      <exit-save v-model="modals.exitSave"/>
    </div>
  </cabinet-layout>
</template>
<script>
import { mapState, createNamespacedHelpers } from 'vuex';

import CabinetLayout from '~/components/redesign/cabinet/main-layout';
import Submenu from '~/components/redesign/cabinet/submenu';
import FormNewSto from '~/components/redesign/cabinet/form-sto-shop';
import ExitSave from '~/components/redesign/cabinet/modal/exit-save';

const STORE_USER = createNamespacedHelpers('user');
export default {
  name: 'WrenchOrganizationNewSto',
  components: {
    CabinetLayout,
    Submenu,
    FormNewSto,
    ExitSave,
  },
  layout: 'cabinet',
  validate({ params, store }) {
    if (!params || !params.id) {
      return true;
    }

    return /^\d+$/.test(params.id)
      && store.state.user.auth.organization.legals
        .some(legal => legal.id === params.id);
  },
  async asyncData({ app, store, params }) {
    const information = {};

    if (params && params.id) {
      information.legal = store.state.user.auth.organization.legals.find(legal => legal.id === params.id);
    }

    information.organization = {
      legals: store.state.user.auth.organization.legals || [],
    };

    if (!store.state.user.auth) {
      return {
        shopAttributes: [],
        paymentMethods: [],
        additionalContactMethods: [],
        carManufacturerWithRegionList: [],
        listService: [],
      };
    }
    const [
      shopAttributes,
      paymentMethods,
      additionalContactMethods,
      carManufacturerWithRegionList,
      ListService,
    ] = await Promise.all([
      // @todo нормальная обработка ошибок
      app.$axios.$get('/_main/refShopAttributes/get').catch((error) => { console.error(error); }),
      app.$axios.$get('/_main/refPaymentMethods/get').catch((error) => { console.error(error); }),
      app.$axios.$get('/_main/refAdditionalContactMethods/get').catch((error) => { console.error(error); }),
      app.$axios.$get('/_main/carManufacturer/getWithRegion').catch((error) => { console.error(error); }),
      app.$axios.$get('/_main/refStoServiceGroups/get').catch((error) => { console.error(error); }),
    ]);
    return {
      shopAttributes: shopAttributes ? shopAttributes.data : [],
      paymentMethods: paymentMethods ? paymentMethods.data : [],
      additionalContactMethods: additionalContactMethods ? additionalContactMethods.data : [],

      carManufacturerWithRegionList: carManufacturerWithRegionList
        ? carManufacturerWithRegionList.data
        : {},

      listService: ListService
        ? ListService.data
        : [],

      information,
    };
  },
  data() {
    return {
      modals: {
        exitSave: false,
      },
    };
  },
  computed: {
    ...mapState(['location']),
    ...STORE_USER.mapState(['auth']),
  },
  methods: {
    exitSaveAction() {
      this.modals.exitSave = true;
    },
  },
};
</script>

<style scoped lang="scss">
  .question {
    @media screen and (max-width: 980px) {
      display: none;
    }
    @media screen and (min-width: 981px) {
      position: relative;
      display: inline-flex;
      > .button {
        display: inline-flex;
        justify-content: center;
        align-items: center;
        width: 1rem;
        height: 1rem;
        background: transparent;
        border: 1px solid #9badb9;
        border-radius: 50%;
        outline: 0;
        cursor: pointer;
        &:before {
          display: inline-flex;
          content: "?";
          font-size: 0.75rem;
          font-weight: normal;
          line-height: 1;
          color: #4272a4;
        }
      }
    }
  }

  .wrench {
    display: flex;
    flex-flow: column nowrap;
    justify-content: flex-start;
    align-items: stretch;
    width: 100%;
    .container {
      display: flex;
      flex-flow: column nowrap;
      justify-content: flex-start;
      align-items: flex-start;
      padding: 1.5rem;
      @media screen and (max-width: 980px) {
        display: none;
      }

      .title {
        display: block;
        line-height: 1.3;
        font-weight: 700;
        padding: 1.5rem 0 0;
        margin: 0;
        font-size: 1rem;
      }

      .subtitle {
        display: block;
        line-height: 1.3;
        font-weight: 500;
        padding: 0 0 1rem 0;
        font-size: 0.875rem;
        &.details {
          padding-top: 1rem;
        }
      }

    }
  }
</style>
